﻿using System;
using System.Collections.Generic;
using System.Text;
using Syncfusion.SfCalendar.XForms;
using Xamarin.Forms;

namespace CalendarAppointment
{
    public class CalendarBehavior : Behavior<ContentPage>
    {
        SfCalendar calendar;
        CalendarEventCollection appointments;
        Label appCount;

        protected override void OnAttachedTo(ContentPage bindable)
        {
            base.OnAttachedTo(bindable);
            appCount = bindable.FindByName<Label>("indicator");
            calendar = bindable.FindByName<SfCalendar>("calendar");
            calendar.OnMonthCellLoaded += Calendar_OnMonthCellLoaded;
        }

        private void Calendar_OnMonthCellLoaded(object sender, MonthCellLoadedEventArgs args)
        {
            var viewModel = (calendar.BindingContext as CalendarViewModel);
            viewModel.Date = args.Date;
            viewModel.IsAppointment = false;
            viewModel.AppCount = "";
          
            appointments = calendar.DataSource as CalendarEventCollection;

            for (int i = 0; i < appointments.Count; i++)
            {
                var appointment = appointments[i];
                if (args.Date.Date == appointment.StartTime.Date)
                {
                    // Count Starts from 0
                    viewModel.AppCount = (i + 1).ToString();
                    viewModel.IsAppointment = true;
                }
            }

            args.CellBindingContext = viewModel;
        }
    }
}
